<template>
    <div class="stats">
        <div class="stats-line avg">
            <div class="name">Average</div>
            <div class="nums">
                <div class="num" v-if="average('1') || average('1X')">
                    {{ average('1') || average('1X') }}
                </div>
                <div class="num" v-if="average('X') || average('12')">
                    {{ average('X') || average('12') }}
                </div>
                <div class="num" v-if="average('2') || average('X2')">
                    {{ average('2') || average('X2') }}
                </div>
                <div class="num percent">{{ calculatePercent([...Object.values(bets[0].coefficients)]) }}%</div>
            </div>
        </div>
        <div class="stats-line highest">
            <div class="name">Highest</div>
            <div class="nums">
                <div class="num" v-if="highest['1'] || highest['1X']">
                    {{ highest['1'] || highest['1X'] }}
                </div>
                <div class="num" v-if="highest['X'] || highest['12']">
                    {{ highest['X'] || highest['12'] }}
                </div>
                <div class="num" v-if="highest['2'] || highest['X2']">
                    {{ highest['2'] || highest['X2'] }}
                </div>
                <div class="num percent">{{ calculatePercent([...Object.values(highest)]) }}%</div>
            </div>
        </div>
    </div>
</template>

<script>
export default {
    name: 'MatchStats',
    props: {
        bets: {
            type: Array,
            required: true
        }
    },
    data() {
        return {
            highest: {}
        }
    },
    watch: {
        bets() {
            this.calculateMax()
        }
    },
    methods: {
        calculatePercent(values) {
            let itemsSum = 0;
            values.map(el => {
                itemsSum += 1 / parseFloat(el)
            })
            return (1 / itemsSum * 100).toFixed(2)
        },
        calculateMax() {
            let highest = {};
            let typesUnique = this.bets[0].coefficientsGroups
            typesUnique.map(type => {
                let max;
                Object.values(this.bets[0].bets).map((el, index) => {
                    if (index === 0) { max = 0 }

                    if ( el[type] ) {
                        max = max < parseFloat(el[type].price) ? parseFloat(el[type].price) : max
                    }

                    if ( index+1 === Object.keys(this.bets[0].bets).length ) {
                        highest[type] = max.toFixed(2)
                    }
                });
            })

            this.highest = highest
        },
        average(coeffName) {
            if (!this.bets[0].coefficients[coeffName]) return false
            return this.bets[0].coefficients[coeffName].toFixed(2)
        }
    },
    created() {
        this.calculateMax()
    }
}
</script>
